﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace Sample.Models
{
    public class EmployeeRepository
    {
        public static IList<EmployeeModel> GetAllRecords()
        {
            IList<EmployeeModel> employees = (IList<EmployeeModel>)HttpContext.Current.Session["Employees"];

            if (employees == null)
            {
                HttpContext.Current.Session["Employees"] = employees = (from emp in new NorthWndDataContext().Employees.Take(200)
                                                                        select new EmployeeModel
                                                                        {
                                                                            EmployeeID = emp.EmployeeID,
                                                                            FirstName = emp.FirstName,
                                                                            LastName = emp.LastName,
                                                                            BirthDate = emp.BirthDate,
                                                                            HireDate = emp.HireDate,
                                                                            Title = emp.Title,
                                                                            City = emp.City,
                                                                            Country = emp.Country
                                                                        }).ToList();

            }
            return employees;
        }
        public static void Add(EmployeeModel employee)
        {            
                GetAllRecords().Insert(0, employee);
        }

        public static void Delete(int employeeID)        {
           
                EmployeeModel result = GetAllRecords().Where(o => o.EmployeeID == employeeID).FirstOrDefault();
                GetAllRecords().Remove(result);            
        }

        public static void Update(EmployeeModel employee)
        {
            EmployeeModel result = GetAllRecords().Where(o => o.EmployeeID == employee.EmployeeID).FirstOrDefault();
                if (result != null)
                {
                    result.EmployeeID = employee.EmployeeID;
                    result.FirstName = employee.FirstName;
                    result.LastName = employee.LastName;
                    result.BirthDate = employee.BirthDate;
                    result.HireDate = employee.HireDate;
                    result.Title = employee.Title;
                    result.City = employee.City;
                    result.Country = employee.Country;

                }           
        }
    }
}